// ClassExampleDlg.h : header file
//

#if !defined(AFX_CLASSEXAMPLEDLG_H__01159D07_51F5_49D7_9A39_01EEE8E06E72__INCLUDED_)
#define AFX_CLASSEXAMPLEDLG_H__01159D07_51F5_49D7_9A39_01EEE8E06E72__INCLUDED_

#pragma once

#include "afxcmn.h"
#include "afxwin.h"
#include "./GraphicsAPI/GraphicsAPI.h"

/////////////////////////////////////////////////////////////////////////////
// CClassExampleDlg dialog
//
//
class TmodelControl;
class TrawMeshSurfaceControl;
class TmyWorld;
class Tcamera;
class Td3dDrawable;
class Td3dZoomDrawable;
class CClassExampleDlg : public CDialog
{
// Construction
public:
	CClassExampleDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CClassExampleDlg)
	enum { IDD = IDD_CLASSEXAMPLE_DIALOG };
	CString	m_StatusArea;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CClassExampleDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CClassExampleDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnQuit();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	///////////////////////////////////////////////////////////////
	// 
	// Code added in by Kelvin
	//
	public:
		void 	EchoToStatusArea(CString);
		float	GetSliderBarValue(CSliderCtrl&);

	private:
		void	ComputeResizing();
		bool 	OnKeyDown(UINT nChar);
		void 	InitializeSlider(CSliderCtrl&, CString &echo, float min, float max, float init);
		void 	UpdateSliderEcho(CString &echo, float value);

		
		LPDIRECT3D9		fD3d;
		
		// Normal View
		Td3dDrawable	*fDrawable;
		Tcamera			*fMyCamera;

		// Zoom View
		Td3dZoomDrawable	*fZoomDrawable;
		Tcamera				*fZoomCamera;

		//
		// model control and the model
		// 
		TmodelControl	*fControl;
		TrawMeshSurfaceControl *fRawMeshSurfaceControl;
		TmyWorld		*fMyWorld;
		
				
		// To support moving the Quit button as the window size changes
		int					fQuitDistanceToEdge;

		// This is the size of the based Dialog window, remember, the
		// origin of the world is top left!!
		int					fDialogWidth;
		int					fDialogHeight;

		//
		// TopLeft where Td3dDrawable can stay in, this would be
		// areas outside of the controls and echos/quit button
		// BottomRight for Td3dDrawable will always be the DialogWidth/Height
		int					fDrawableTop;
		int					fDrawableLeft;

public:
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	CButton m_QuitButton;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CLASSEXAMPLEDLG_H__01159D07_51F5_49D7_9A39_01EEE8E06E72__INCLUDED_)
