#ifndef T_RAW_MESH_H
#define T_RAW_MESH_H

//
//****************************************************************************************************
// Copied and massage from DXSDK 9: D3D Tutorial 6 on mesh
//	
// Date: Jan 2003
//	 By: Kelvin Sung
//
#include "../GraphicsAPI/GraphicsAPI.h"

class Tmaterial;
class TrawMesh {
	
	private:
		LPD3DXMESH              fMesh; 			// Our mesh object in sysmem
		D3DMATERIAL9*           fMeshMaterials; // Materials for our mesh
		LPDIRECT3DTEXTURE9*     fMeshTextures;  // Textures for our mesh
		unsigned long			fNumMaterials;  // Number of mesh materials
		LPDIRECT3DDEVICE9		fDevice;		// Which device will store this mesh
		ID3DXMatrixStack*		fStack;			// For scaling object size/location to norm

		D3DXVECTOR3				fObjectCenter;        // Center of bounding sphere of object
		FLOAT					fObjectRadius;        // Radius of bounding sphere of object
	
		void	SetUpD3DStack(ID3DXMatrixStack *stack);
	public:

		TrawMesh();
		~TrawMesh();


		BOOL	LoadMesh(LPDIRECT3DDEVICE9, ID3DXMatrixStack*, CString path, CString fileName);
		VOID	DrawMesh(bool);
		VOID	DrawRawMesh(bool);
		bool    RayPickMesh(const D3DXVECTOR3 &, const D3DXVECTOR3 &);
};

#endif

