#ifndef T_TEXTURE_LIBRARY
#define T_TEXTURE_LIBRARY

#include "../GraphicsAPI/GraphicsAPI.h"

////////////////////////////////////////////////////////////////////////////////////////////////////
//
//  To add new texture into the library do:
//
//    1. Add in a new index for the texture in TfileTextureIndex enum
//
//    2. copy the image file to sfPathToTexture
//
//    3. add in an entry to the sfAllTextures[] array with the new index and image file name
//
//
////////////////////////////////////////////////////////////////////////////////////////////////////
//
//
enum TfileTextureIndex {
	eCMMRTexture = 0,
	eKelvinInOfficeTexture = 1,
	eTigerTexture = 2,

	eInvalidTexture = -1

};

class Ttexture;

class TtextureLibrary {
		
	private:
		#define sfTextureLibrarySize 256

		Ttexture	*fTextureLibrary[sfTextureLibrarySize];

	public:
		TtextureLibrary();
		~TtextureLibrary();

		void	 InitializeTextureLibrary(LPDIRECT3DDEVICE9);

		void	 SetTextureToLibrary(Ttexture *t, int i);
		Ttexture *GetTextureFromLibrary(int index);
};

#endif
