#ifndef  GRAPHICS_API_H
#define  GRAPHICS_API_H


////////////////////////////////////////////////////////////////////////////////////////
//
// Limitation with this API:
//
//
#include "../StdAfx.h"

#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <cmath>       // for cos(), sin(), and sqrt() 


#include <d3d9.h>
#pragma comment(lib, "d3d9.lib")
		// Direct 3D include file (Remember to link with d3d9.lib)

#include <d3dx9mesh.h>
		// for D3DX - classes (e.g. D3DX_VECTOR, etc.)
#include <d3dx9math.h>
		// for D3DX - math classes ... (Remember to link with d3dx9.lib)


#pragma comment(lib, "d3dx9.lib")
	
#include "TmyVertex.h"
		// Almost everyone needs to know about what is our
		// vertex format

// Some <math.h> files do not define M_PI... 
// 
#ifndef M_PI
#define M_PI 3.14159265358979323846f
#endif

#ifndef M_VERY_LARGE 
#define M_VERY_LARGE 10000000.0f
#endif

class Td3dDrawable;
class Tmaterial;

#define SAFE_RELEASE(_p) if ((_p) != NULL) { (_p)->Release(); (_p) = NULL; }
#define SAFE_DELETE(_p)  if ((_p) != NULL) { delete (_p); (_p) = NULL; }
//
//
// 
extern const D3DXVECTOR3 sfXAxis;
extern const D3DXVECTOR3 sfYAxis;
extern const D3DXVECTOR3 sfZAxis;

extern		 Tmaterial   sfNoLightMat;


//
// export from RandNum.cpp
extern float RandomNumber(float range);
	// returns a random number in the 0<->range range.
extern float RandomNumber(float minRange, float maxRange);
	// returns a random number between minRange and maxRange
extern void RandomTriple(float minRange, float maxRange, D3DXVECTOR3 &c);
	// returns three random numbers in the c-float array


//
// export from Message.cpp
//
void WarningBox(const char *msg);
void ErrorMessage(HRESULT hr, const char *msg);
void EchoToStatusArea(CString msg);

// #define DEBUG_RELEASE
#undef DEBUG_RELEASE
#ifdef DEBUG_RELEASE
	void LogToFile(const char *msg);
#else
	#define LogToFile(msg)	
#endif
	
#endif
