#include "Tarrow.h"

Tarrow::Tarrow()
{
	fBody.SetMeshIndex(eCylinderMesh);
	fBody.SetScale(0.02, 0.02, 0.7);
	fBody.SetRotation(M_PI/2.0, 0, 0);
	fBody.SetLocationTo(0, 0.55, 0);
	fBody.SetDrawColor(D3DXCOLOR(0.6, 0.95, 0.6, 0));

	fHead.SetMeshIndex(eConeMesh);
	fHead.SetScale(0.1, 0.1, 0.2);
	fHead.SetRotation(M_PI/2.0, 0, 0);
	fHead.SetLocationTo(0, 1.1, 0);
	fHead.SetDrawColor(D3DXCOLOR(0.95, 0.2, 0.2, 0));
}

void
Tarrow::SetArrowColor(
	const D3DXCOLOR &h,	// head color
	const D3DXCOLOR &b 	// body color
)
{
	fHead.SetDrawColor(h);
	fBody.SetDrawColor(b);
}


void
Tarrow::DrawObjectGeom(
	Td3dDrawable &d,
	LPDIRECT3DDEVICE9 device
)
{
	fHead.DrawObject(d);
	fBody.DrawObject(d);
}
