#include "Tcamera.h"

float Tcamera::GetViewDistance() { return fViewDistance; }

void  
Tcamera::SetViewDistance(float d) 
{
	fViewDistance = d; 
	UpdatePosition();
}


void Tcamera::UpdatePosition()
{
	D3DXVECTOR3 p;
	if (fMoveEyePosition) {
		// fEyePosition will be changed to 
		// fViewDistance away fromt the fLookAt 
		fEyePosition = fLookAt - (fViewDistance * fV);
	} else {
		fLookAt = fEyePosition + (fViewDistance * fV);
	}
}

void Tcamera::SetCameraTrack(float dx, float dy)
{
	fEyePosition = fEyePosition + (fW * dx) + (fU * dy);
	fLookAt = fLookAt + (fW * dx) + (fU * dy);
}

void Tcamera::InitializeUVW()
{
	fV = fLookAt - fEyePosition;
	fViewDistance = D3DXVec3Length(&fV);
	D3DXVec3Normalize(&fV, &fV);

	D3DXVec3Cross(&fW, &fUpVector, &fV);
	D3DXVec3Normalize(&fW, &fW);

	D3DXVec3Cross(&fU, &fV, &fW);
	D3DXVec3Normalize(&fU, &fU);
	// 
	fUpVector = fU;
}

void 
Tcamera::SetLocationTo(float x, float y, float z) {
	if (fMoveEyePosition) {
		fEyePosition.x = x;
		fEyePosition.y = y;
		fEyePosition.z = z;
	} else {
		fLookAt.x = x;
		fLookAt.y = y;
		fLookAt.z = z;
	}
	InitializeUVW();
}

const D3DXVECTOR3& 
Tcamera::GetLocation() const
{
	if (fMoveEyePosition) {
		return fEyePosition;
	} else {
		return fLookAt;
	}
}