#include "Tcircle.h"
#include "../Td3dDrawable.h"

Tcircle::Tcircle()
{
	InitializeCircleObject();
}

void Tcircle::InitializeCircleObject()
{
	float theta, delta;
	int	   count;

	int r = 0;

	theta = 2*M_PI;
	delta = 2 * M_PI / float(sfNumVertices-2);

	// Point 0 is the center of the TriangleFan
	//
	fV[0].fPoint = D3DXVECTOR3(0.0f, 0.0f, 0.0f);
	fV[0].fNormal = D3DXVECTOR3(0, 1, 0);
	fV[0].fU = fV[0].fU1 = 0.5f;
	fV[0].fV = fV[0].fV1 = 0.5f;
	
	for (count=1; count<(sfNumVertices-1); count++) {

		//
		// Coordinate for unit circle
		//
		float x = cosf(theta);
		float y = sinf(theta);

		fV[count].fPoint = D3DXVECTOR3(x, 0.0f, y);
		fV[count].fNormal = D3DXVECTOR3(0, 1, 0);
		fV[count].fU = fV[count].fU1 = (fV[count].fPoint.x+1.0f)*0.5f;
		fV[count].fV = fV[count].fV1 = (1.0f-fV[count].fPoint.z)*0.5f;
	
		theta -= delta;
	}

	fV[sfNumVertices-1] = fV[1];
}

void Tcircle::DrawObjectGeom(
	Td3dDrawable 	   &d,
	LPDIRECT3DDEVICE9  d3dDevice
) 
{

	//
	// Draw the unit circle and we are DONE!!
	//
	d3dDevice->SetFVF(kMyVertexFormat);
	d3dDevice->DrawPrimitiveUP(D3DPT_TRIANGLEFAN, sfNumVertices-2, (CONST void *)fV, sizeof(TmyVertex));
}
