#include "Tmesh.h"
#include "../Collections/TrawMesh.h"
#include "../Td3dDrawable.h"



Tmesh::Tmesh() : fMeshIndex(eInvalidMesh)
{}


Tmesh::Tmesh(TmeshObjectIndex i) : fMeshIndex(i)
{}

void Tmesh::SetMeshIndex(TmeshObjectIndex i) {
	fMeshIndex = i;
}


void 
Tmesh::DrawObjectGeom(
	Td3dDrawable &d, 
	LPDIRECT3DDEVICE9 device
)
{
	if (fMeshIndex != eInvalidMesh) {
		TrawMesh *m = d.fMeshLibrary.GetMeshFromLibrary(fMeshIndex);

		#ifdef DEBUG_RELEASE
			CString msh;
			msh.Format("Tmesh(%d): Pointer(%x)", fMeshIndex, m);
			LogToFile(msh);
		#endif

		if (m != NULL) {
			//
			// At this point Tmesh::SetObjectD3DAttribute has already set the
			// TgraphicsObject (super class of Tmesh) fMaterial into the hw pipe
			// we are going to tell TrawMesh to not worry about setting material
			// if it is not switched on.
			//
			m->DrawMesh(fLighting);
		}
	}
}

bool
Tmesh::RayPickObjectGeom(
	Td3dDrawable &d, 
	LPDIRECT3DDEVICE9 device,
	const D3DXVECTOR3 &o,
	const D3DXVECTOR3 &dir
)
{
	bool picked = false;

	if (fMeshIndex != eInvalidMesh) {
		TrawMesh *m = d.fMeshLibrary.GetMeshFromLibrary(fMeshIndex);
		if (m != NULL)
			picked = m->RayPickMesh(o, dir);
	}
	return picked;
}
