#include "ToffsetMesh.h"

//
// Assumptions here is:
//
//	1. the y-direction is up direction
//  2. bounding sphere radius of the TrawMesh touches the object's y
// 


ToffsetMesh::ToffsetMesh() : fObject(eCylinderMesh), fRefPos(0, 0, 0)
{}


ToffsetMesh::ToffsetMesh(TmeshObjectIndex i) : fObject(i), fRefPos(0, 0, 0)
{}

void 
ToffsetMesh::SetObjectD3DTransformation(
	ID3DXMatrixStack *stack
) const
{
	stack->TranslateLocal(fXformInfo.MoveX(), fXformInfo.MoveY(), fXformInfo.MoveZ());

	stack->TranslateLocal(fRefPos.x, fRefPos.y, fRefPos.z);
		fXformInfo.GetRotation().SetToStack(stack);	
		stack->ScaleLocal(fXformInfo.ScaleX(), fXformInfo.ScaleY(), fXformInfo.ScaleZ());
	stack->TranslateLocal(-fRefPos.x, -fRefPos.y, -fRefPos.z);
}


void ToffsetMesh::SetObjectD3DAttributes(
	Td3dDrawable &d)
{
	fObject.SetMaterial(GetMaterial());
	
	if (fLighting)
		fObject.EnableLighting();
	else
		fObject.DisableLighting();

	if (fShowAxisFrame)
		fObject.EnableShowAxisFrame();
	else
		fObject.DisableShowAxisFrame();
}

void 
ToffsetMesh::DrawObjectGeom(
	Td3dDrawable &d,
	LPDIRECT3DDEVICE9 
)
{
	fObject.DrawObject(d);
}
