#include "Tpoint.h"
#include "../Td3dDrawable.h"


Tpoint::Tpoint()
{
	InitializePointObject();
}

ImplementSimpleObjAttr(Tpoint, float, PointSize);

void
Tpoint::InitializePointObject()
{
	fV.fPoint.x = 0;
	fV.fPoint.y = 0;
	fV.fPoint.z = 0;
	fV.fNormal.x = 0;
	fV.fNormal.y = 0;
	fV.fNormal.z = 0;
	fV.fU = fV.fV = 0;
	fV.fU1 = fV.fV1 = 0;
	fPointSize = 1.0f;
}

void 
Tpoint::SetVertex(float x, float y, float z) {
	fV.fPoint.x = x;
	fV.fPoint.y = y;
	fV.fPoint.z = z;
}
	
void Tpoint::SetObjectD3DAttributes(
	Td3dDrawable &d
)
{
	TdrawableObject::SetObjectD3DAttributes(d);
	d.D3DDevice()->SetRenderState( D3DRS_POINTSIZE,	*((DWORD*)(&fPointSize)));
}


void Tpoint::DrawObjectGeom(
	Td3dDrawable 	   &,
	LPDIRECT3DDEVICE9  d3dDevice
) 
{
	//
	// Draw the unit circle from CPU memory
	//
	d3dDevice->SetFVF(kMyVertexFormat);
	d3dDevice->DrawPrimitiveUP(D3DPT_POINTLIST, 1, (CONST void *)(&fV), sizeof(TmyVertex));
}