#include "Trectangle.h"
#include "../Td3dDrawable.h"


Trectangle::Trectangle()
{
	InitializeRectangleObject();
}

Trectangle::Trectangle(float scale)
{
	InitializeRectangleObject();
	fXformInfo.SetScale(scale);
}

void Trectangle::InitializeRectangleObject()
{
	int count = 0;
	fV[count].fPoint = D3DXVECTOR3(-0.5f, 0, 0.5f);
	fV[count].fNormal = D3DXVECTOR3(0, 1, 0);
	fV[count].fU = fV[count].fU1 = fV[count].fPoint.x+0.5f;
	fV[count].fV = fV[count].fV1 = fV[count].fPoint.z+0.5f;
	
	count++;
	fV[count].fPoint = D3DXVECTOR3( 0.5f, 0,  0.5f);
	fV[count].fNormal = D3DXVECTOR3(0, 1, 0);
	fV[count].fU = fV[count].fU1 = fV[count].fPoint.x+0.5f;
	fV[count].fV = fV[count].fV1 = fV[count].fPoint.z+0.5f;
	
	count++;
	fV[count].fPoint = D3DXVECTOR3(-0.5f, 0, -0.5f);
	fV[count].fNormal = D3DXVECTOR3(0, 1, 0);
	fV[count].fU = fV[count].fU1 = fV[count].fPoint.x+0.5f;
	fV[count].fV = fV[count].fV1 = fV[count].fPoint.z+0.5f;
	
	count++;
	fV[count].fPoint = D3DXVECTOR3( 0.5f, 0, -0.5f);
	fV[count].fNormal = D3DXVECTOR3(0, 1, 0);
	fV[count].fU = fV[count].fU1 = fV[count].fPoint.x+0.5f;
	fV[count].fV = fV[count].fV1 = fV[count].fPoint.z+0.5f;
}


void Trectangle::DrawObjectGeom(
	Td3dDrawable 	   &drawable,
	LPDIRECT3DDEVICE9  d3dDevice
) 
{

	if (fXformInfo.ScaleX() < 0)
		return;

	d3dDevice->SetFVF(kMyVertexFormat);
	d3dDevice->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP, 2, (CONST void *)fV, sizeof(TmyVertex) );
}
