#include "Ttriangle.h"
#include "../Td3dDrawable.h"

void Ttriangle::InitializeTriangleObject()
{
	int count = 0;
	fV[count].fPoint = D3DXVECTOR3(0.5f, 0, -0.3f);
	fV[count].fNormal = D3DXVECTOR3(0, 1, 0);
	fV[count].fU = fV[count].fU1 = 1.0f;
	fV[count].fV = fV[count].fV1 = 0.0f;
	
	count++;
	fV[count].fPoint = D3DXVECTOR3( 0.0f,  0, 0.566f);
	fV[count].fNormal = D3DXVECTOR3(0, 1, 0);
	fV[count].fU = fV[count].fU1 = 0.0f;
	fV[count].fV = fV[count].fV1 = 0.5f;
	
	count++;
	fV[count].fPoint = D3DXVECTOR3(-0.5f, 0, -0.3f);
	fV[count].fNormal = D3DXVECTOR3(0, 1, 0);
	fV[count].fU = fV[count].fU1 = 0.0f;
	fV[count].fV = fV[count].fV1 = 0.0f;
}


Ttriangle::Ttriangle()
{
	InitializeTriangleObject();
}

Ttriangle::Ttriangle(float s)
{
	InitializeTriangleObject();
	fXformInfo.SetScale(s);
}

void Ttriangle::DrawObjectGeom(
	Td3dDrawable 	   &drawable,
	LPDIRECT3DDEVICE9  d3dDevice
) 
{

	if (fXformInfo.ScaleX() < 0)
		return;

		//
		// Draw the unit triangle from User Pointer ...
		//
	d3dDevice->DrawPrimitiveUP(D3DPT_TRIANGLELIST, 1, (CONST void *)fV, sizeof(TmyVertex));
		
}
