#include "Stdafx.h" //for MFC stuff
#include <d3d9.h> //for D3D error messages
#include <d3dx9.h>
#include "ClassExample.h" //for inclusion of resource.h

#include "GraphicsAPI/GraphicsAPI.h"

void EchoToStatusArea(CString msg)
{
  //ASSUMPTION - We have a item on our main dialog with an ID of IDC_STATUS_AREA
  //
  // This is from Steve Bear - by accessing the control directly, he eliminated the need for
  // for access the ugly gGlobalMessage pointer. 
  //
  CWnd* pMainWnd = ::AfxGetMainWnd();
  if(pMainWnd){
    HWND hStatus = ::GetDlgItem(pMainWnd->m_hWnd,IDC_STATUS_AREA);
    if(hStatus) ::SetWindowText(hStatus,(LPCTSTR)msg);
  }
}


void WarningBox(const char *msg)
{
//	extern Td3dDrawable *gErrorHandler;

	//
	// This is the WindowHandle of the main
	// drawing window, forced globl for us
	// to get access to MessageBox.
	//
  //SAB - Unnecessary. Just call Win32 Messagebox with no owner window (NULL)
  ::MessageBox(NULL,msg,"Warning",MB_ICONERROR|MB_OK);
}

#ifdef DEBUG_RELEASE
void LogToFile(const char *msg) {
		static CStdioFile sfLogFile("LogFile.txt", CFile::modeCreate | CFile::modeWrite | CFile::typeText);
		sfLogFile.WriteString(msg);
		sfLogFile.WriteString("\n");
		sfLogFile.Flush();
}
#endif

void ErrorMessage(HRESULT hr, const char *msg)
{

	#define CaseLabel(__label, __labelMsg) 						\
		case __label:											\
			{													\
				char outMsg[100];								\
				sprintf(outMsg, "%s : %s", __labelMsg, msg);	\
				WarningBox(outMsg);								\
				break;											\
			}



	switch (hr) {
		CaseLabel(D3DERR_NOTAVAILABLE, "D3DERR_NOTAVAILABLE")


		CaseLabel(D3DERR_OUTOFVIDEOMEMORY, "D3DERR_OUTOFVIDEOMEMORY")


		CaseLabel(D3DERR_INVALIDCALL, "D3DERR_INVALIDCALL")


		CaseLabel(D3DXERR_INVALIDDATA, "D3DXERR_INVALIDDATA")


		CaseLabel(E_OUTOFMEMORY, "E_OUTOFMEMORY")



		CaseLabel(-1, "Undefined Error")
		

		case D3D_OK:

			break;


	}
}
