#include "TmeshSurface.h"
#include "../Collections/TrawMeshSurface.h"
#include "../Td3dDrawable.h"

ImplementBoolObjAttr(TmeshSurface, ShowControlGrid)

TmeshSurface::TmeshSurface
() 
		: fMeshSurfaceIndex(eInvalidMeshSurfaceIndex), fShowControlGrid(false)
{}

TmeshSurface::TmeshSurface(int i) 
		: fMeshSurfaceIndex(i), fShowControlGrid(false)
{}

void
TmeshSurface::DrawObjectGeom(Td3dDrawable &d, LPDIRECT3DDEVICE9 device)
{
	if (fMeshSurfaceIndex != eInvalidMeshSurfaceIndex) {
		TrawMeshSurface *m = d.fMeshSurfaceLibrary.GetMeshSurfaceFromLibrary(fMeshSurfaceIndex);
		if (m != NULL) {		
			m->DrawMeshSurface(d);

			Tfillable::UnsetObjectD3DAttributes(d);
			if (ShowNormalIsEnabled())
				m->DrawNormalVectors(d);

			if (ShowControlGridIsEnabled())
				m->DrawMeshControlGrid(d);
		}
	}
}
