#include "TmyWorld.h"
#include "../Resource.h"
#include "../TmodelControl.h"
#include "../Collections/TmeshLibrary.h"
#include "../Collections/TtextureLibrary.h"
#include "../Td3dDrawable.h"
#include "../GraphicsAPI/Tcamera.h"


#define POINT_LIGHT_ID 		2
#define DIRECTION_LIGHT_ID 	1
#define SPOT_LIGHT_ID 		0

TmyWorld::TmyWorld() : 
		fPointLgt(POINT_LIGHT_ID),
		fDirLgt(DIRECTION_LIGHT_ID),
		fSpotLgt(SPOT_LIGHT_ID)
{
	fValidPickRay = false;
	fControl = NULL;
	
	// fCraft - nothing for now ...

	fMainFrame.SetScale(5);

	fGround.SetScale(20, 20, 20);
	fGround.SetMeshSurfaceIndex(0);
	fGround.SetTextureIndex(1);
	Tmaterial &mt = fGround.GetMaterial();
	mt.SetDiffuse(0.3);

	fTeapot.SetScale(3, 3, 3);
	fTeapot.SetLocationTo(0, 1.5, 0);
	fTeapot.SetMeshIndex(eTeapotMesh);
	fTeapot.SetTextureIndex(0);
	Tmaterial &tmt = fTeapot.GetMaterial();
	tmt.SetDiffuse(0.5);

	fPointLgt.SetLocationTo(10, 10, 10);
	// fPointLgt.DisableVisibility();
	Tmaterial &pmt = fPointLgt.GetMaterial();
	pmt.SetDiffuse(0.5, 0.5, 0.5);
	
	fDirLgt.SetLocationTo(10, 20, 0);
	Tmaterial &dmp = fDirLgt.GetMaterial();
	dmp.SetDiffuse(0.9, 0.7, 0.9);


	fToyCraft.SetLocationTo(5, 0, 5);
	fToyCraft.SetScale(2, 2, 2);

	fBlocker.SetScale(20, 20, 20);
	fBlocker.SetLocationTo(0, 10, 0);
	fBlocker.SetMeshSurfaceIndex(0);
	fBlocker.SetTextureIndex(2);
	// fBlocker.EnableShowTexture();
	fBlocker.EnableLighting();
	Tmaterial &bmt = fBlocker.GetMaterial();
	bmt.SetEmissive(0);
	bmt.SetDiffuse(0.6, 0.6, 0.6, 1.0);

	// This is our "magic" x-ray light, which shoots out 
	fSpotLgt.SetLocationTo(0, 20, 0);
	fSpotLgt.DisableVisibility();
	Tmaterial &smp = fSpotLgt.GetMaterial();
	smp.SetDiffuse(0.6, 0.2, 0.2);
	
}

void
TmyWorld::SetControl(
	TmodelControl *c
)
{
	fControl = c;
}
