#include "./TtoyCraft.h"

TtoyCraft::TtoyCraft()
{
	fBasePiece.SetMeshIndex(eCylinderMesh);
	fBasePiece.SetDrawColor(D3DXCOLOR(0.15, 0.15, 0.3, 1) );
	fBasePiece.SetRotation(-M_PI/2.0, 0, 0);
	fBasePiece.SetScale(1.5, 1.5, 0.1);
	fBasePiece.SetLocationTo(0, 0.1*CylinderHeight, 0);
							// Translation in Y -> this is the rotated coordinate

	TgraphicsObject *o = fCraft.GetObject();
	// fCraft.SetMeshIndex(eCraftMesh);
	fCraft.SetMeshIndex(eShusuiMesh);
	fCraft.SetReferencePos(0, CraftLocation, 0);
	o->SetDrawColor(D3DXCOLOR(0.35, 0.15, 0.15, 1) );
	o->SetLocationTo(0, CraftLocation, 0);


	o = fBaseStick.GetObject();
	fBaseStick.SetMeshIndex(eCylinderMesh);
	o->SetDrawColor(D3DXCOLOR(0.15, 0.35, 0.15, 1) );
	o->SetRotation(-M_PI/2.0, 0, 0);
	o->SetScale(BaseStickRadius, BaseStickRadius, BaseStickHeight);
	o->SetLocationTo(0, BaseStickLocation, 0);
							// Translation in y -> this is the rotated cooridnate
}

bool 
TtoyCraft::RayPickObjectGeom(Td3dDrawable &d, LPDIRECT3DDEVICE9 p, 
								const D3DXVECTOR3 &o, const D3DXVECTOR3 &dir) {
						
		return fCraft.RayPickObject(d, o, dir) || 
			   fBaseStick.RayPickObject(d, o, dir) || 
			   fBasePiece.RayPickObject(d, o, dir);
						
}

