#ifndef T_TOY_CRAFT_H
#define T_TOY_CRAFT_H


#include "../GraphicsAPI/TgraphicsObject.h"
#include "../GraphicsAPI/ToffsetMesh.h"

#define CylinderHeight     0.83 
				// look at Collections/TmeshLibrary.cpp for this
				//
				
#define BaseStickRadius    0.3
#define BaseStickHeight    1.0
#define BaseStickLocation  (BaseStickHeight*CylinderHeight)


#define CraftLocation		(2.0*BaseStickLocation)


class TtoyCraft : public TgraphicsObject {

		ToffsetMesh 	fCraft;
		ToffsetMesh		fBaseStick;
		Tmesh			fBasePiece;
	
	protected:
		//
		// from TgraphicsObject
		//
		virtual void DrawObjectGeom(Td3dDrawable&, LPDIRECT3DDEVICE9);
		virtual bool RayPickObjectGeom(Td3dDrawable &d, LPDIRECT3DDEVICE9 p, 
								const D3DXVECTOR3 &o, const D3DXVECTOR3 &dir);

	public:
		TtoyCraft();

		TgraphicsObject* GetBaseStick() { return &fBaseStick; }
		TgraphicsObject* GetCraft() { return &fCraft; }
};
#endif
