#include "../Td3dDrawable.h"
#include "./TtoyCraft.h"

void TtoyCraft::DrawObjectGeom(
	Td3dDrawable &d,
	LPDIRECT3DDEVICE9 device

)
{
	
	fBasePiece.DrawObject(d);
	fBaseStick.DrawObject(d);
	//
	// Now the craft's drawing depends on the rotation and scaling of the
	// base stick, and we have to accumulate this ...
	//
	// Hint: in 450, we used TobjectList + Tcomponent classes to implement
	// this "grouping" functionality. Here I want to show you exaclt what we
	// were doing in 450 ...
	//
	// Look at how we did this in 450, where we took advance of the D3DX stack
	// and implemented our class hiding the entire D3D operation. making our
	// using of the classes a piece of cake in our last mp :-)
	//
	// Here I will show you two ways:
	//
	// Method I: let's compose matrics our self
	// Method II: let's use the matrix stack ..
	ID3DXMatrixStack *stack = d.Obj2WldStack();
	// make sure we save the stack!!
	stack->Push();

#undef DO_ALL_OURSELVES_WITH_D3DX_MATRIX

#ifdef DO_ALL_OURSELVES_WITH_D3DX_MATRIX
//************************************************************************************
// Method I: We will build matrix ...

this method is not use at this point ...

	// 1. Since we are a member of the TtoyCraft class, we know the transform of
	//    the "Whole Toy" is already on the stack
	//
	// 2. We want to look at the "BaseStick" transform
	TxformInfo &xt = fBaseStick.GetXformInfo();
	const D3DXVECTOR3 &t = xt.Movement();			// BsaeStick Translation
	const D3DXVECTOR3 &s = xt.Scale();				// baseStick scaling
	const D3DXMATRIX  &r = xt.GetRotationMatrix();	// baseStick rotation
	D3DXMATRIX m, mt, ms;
	D3DXMatrixTranslation(&mt, t.x, t.y, t.z);		// 
	D3DXMatrixScaling(&ms, 1.0, s.y, 1.0);
	D3DXMatrixMultiply(&m, &ms, &r);		// scaling first, then rotation
	D3DXMatrixMultiply(&m, &m, &mt);		// now translation last

	// now: let's take this matrix and load into the stack for Craft to composite
	//      with this matrix to see all the transformation of the BaseStick ...
	stack->MultMatrixLocal(&m);
	
#else  // of DO_ALL_OURSELVES_WITH_D3DX_MATRIX
// Method II: Use D3D Matrix stack ...
	// 1. Since we are a member of the TtoyCraft class, we know the transform of
	//    the "Whole Toy" is already on the stack
	//
	// 2. We want to look at the "BaseStick" transform except some of 
	//    the scaling factors ....... so ...
	TxformInfo &xt = fBaseStick.GetXformInfo();
	const D3DXVECTOR3 &t = xt.Movement();			// BsaeStick Translation
	const D3DXVECTOR3 &s = xt.Scale();				// baseStick scaling
	const D3DXMATRIX  &r = xt.GetRotationMatrix();	// baseStick rotation
	//stack->TranslateLocal(t.x, t.y, t.z);
	//stack->MultMatrixLocal(&r);
	// stack->ScaleLocal(1.0, s.y, 1.0);
#endif


			fCraft.DrawObject(d);
	
	stack->Pop();
	device->SetTransform(D3DTS_WORLD, stack->GetTop());
}
