//
// D3dDrawable_Pick.cpp : Support pick operation ...
//
#include "StdAfx.h"
#include "Td3dDrawable.h"
#include "Model/TmyWorld.h"

//
// The followings are from our GraphicsAPI ...
//
#include "./GraphicsAPI/GraphicsAPI.h"
#include "./GraphicsAPI/Tcamera.h"

void Td3dDrawable::BuildPickRay(CPoint point) 
{

	// D3DXMATRIXA16 16-byte aligned matrix, more efficient with P4 processors
	//
	D3DXMATRIXA16	invView, matProj, matView;

	fD3dDevice->GetTransform(D3DTS_PROJECTION, &matProj);
	fD3dDevice->GetTransform(D3DTS_VIEW, &matView);
	D3DXMatrixInverse( &invView, NULL, &matView );

	
	// Screen to a point on the near clipping plane
	D3DXVECTOR3 ptOnN;
	ptOnN.x =  ( ( (2.0f * point.x) / fWidth ) - 1 ) / matProj._11;
	ptOnN.y = -( ( (2.0f * point.y) / fHeight) - 1 ) / matProj._22;
	ptOnN.z = -1;

	D3DXVECTOR3 pickRayO, pickRayD;

	pickRayO.x = invView._41;
	pickRayO.y = invView._42;
	pickRayO.z = invView._43;

	pickRayD.x = ptOnN.x*invView._11 + ptOnN.y*invView._21 + ptOnN.z*invView._31;
	pickRayD.y = ptOnN.x*invView._12 + ptOnN.y*invView._22 + ptOnN.z*invView._32;
	pickRayD.z = ptOnN.x*invView._13 + ptOnN.y*invView._23 + ptOnN.z*invView._33;

	fMyWorld->SetPickRay(pickRayO, pickRayD);
}
