//
// D3dZoomDrawable_Draw.cpp : This is the main drawing routine
//

#include "StdAfx.h"
#include "Td3dZoomDrawable.h"

//
// The followings are from our GraphicsAPI ...
//
#include "./GraphicsAPI/Tcamera.h"
#include "./GraphicsAPI/Tmesh.h"
#include "./GraphicsAPI/Tline.h"
#include "./GraphicsAPI/Tpoint.h"

void Td3dZoomDrawable::DrawableSpecificDraw() 
{
	if (fD3dDevice == NULL)
		return;

	if (fOtherCamera != NULL) {
		fOtherCamera->DrawObject(*this);
	}
}

void Td3dZoomDrawable::DrawableSpecificInitDraw()
{
	//
	// save current stack ...
	//
	fObj2WorldStack->Push();
		//
		// Rotate the entire world by X and Y 
		//
		fObj2WorldStack->RotateAxisLocal(&sfXAxis, fXRot);
		fObj2WorldStack->RotateAxisLocal(&sfYAxis, fYRot);
		fD3dDevice->SetTransform(D3DTS_WORLD, fObj2WorldStack->GetTop());
}

void Td3dZoomDrawable::DrawableSpecificRestoreDraw()
{
	fObj2WorldStack->Pop();
		fD3dDevice->SetTransform(D3DTS_WORLD, fObj2WorldStack->GetTop());
}
