#if !defined(AFX_TMODELCONTROL_H__5861448C_B323_4C28_97E5_D7288EEB7955__INCLUDED_)
#define AFX_TMODELCONTROL_H__5861448C_B323_4C28_97E5_D7288EEB7955__INCLUDED_
#pragma once

// TmodelControl.h : header file
//

#include "./GraphicsAPI/GraphicsAPI.h"
#include "afxcmn.h"

enum TtextureRepeat {
	eTextureWrap,
	eTextureMirror,
	eTextureClamp,
	eTextureBorder
};

enum TfilterType {
	eLinearFilter,
	ePointFilter
};

enum TxformType {
	eScaleXform,
	eRotateXform,
	eTranslateXform,

	eColorEmissive,
	eColorAmbient,
	eColorDiffuse,
	eColorSpecular
};

enum TobjectType {
	eSupportBaseObject,
	eWholeToyObject,
	eCraftObject,
	eCameraObject,
	eGroundObject,
	eTeapotObject,
	
	ePointLightObject,
	eDirectionalLightObject,
	eSpotLightObject
};

/////////////////////////////////////////////////////////////////////////////
// TmodelControl dialog
class TgraphicsObject;
class TmyWorld;

class TmodelControl : public CDialog
{
// Construction
public:
	TmodelControl(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(TmodelControl)
	enum { IDD = IDD_MODEL_CONTROL };
	CSliderCtrl	m_YSlider;
	CSliderCtrl	m_ZSlider;
	CSliderCtrl	m_XSlider;
	CString	m_XSliderEcho;
	CString	m_YSliderEcho;
	CString	m_ZSliderEcho;
	BOOL	m_AxisFrame;
	BOOL	m_Invisible;
	BOOL	m_WorldAxisFrame;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(TmodelControl)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(TmodelControl)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	TxformType		fXformType;
	TobjectType		fObjectType;

	TmyWorld		*fWorld;
	TgraphicsObject *fCurrentObject;

	void 			InitializeSlider(CSliderCtrl&, CString &echo, float min, float max, float init);
	void 			UpdateSliderEcho(CString &echo, float value);
	void			ObjectSetControl();

public:

	TfilterType		fFilterType;
	TtextureRepeat	fRepeat;
	
	
	void			SetMyWorld(TmyWorld *w) { fWorld = w; OnBnClickedGround(); }

	float			GetSliderBarValue(CSliderCtrl&);
	void			SetSlidersToTranslate(float x, float y, float z);
	void			SetSlidersToScale(float x, float y, float z);
	void			SetSlidersToRotate(float x, float y, float z);
	void			SetSlidersToColor(float r, float g, float b, float a);
	void			ControlSetObject();
	void			CameraSetControl() {
						if (fObjectType == eCameraObject)
							ObjectSetControl();
					}

	void			BuildTexturePlacement(D3DXMATRIX &m);

	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnBnClickedColorEmissive();
	afx_msg void OnBnClickedColorAmbient();
	afx_msg void OnBnClickedColorDiffuse();
	afx_msg void OnBnClickedColorSpecular();
	afx_msg void OnBnClickedPointLight();
	afx_msg void OnBnClickedDirectionLight();
	afx_msg void OnBnClickedSpotLight();
	BOOL m_Lighting;
	BOOL m_GouraudShading;
	BOOL m_WireFrame;
	afx_msg void OnBnClickedGround();
	BOOL m_ShowNormal;
	BOOL m_ShowTexture;
	BOOL m_Transparent;
	BOOL m_ControlGrid;
	afx_msg void OnCraft();
	afx_msg void OnRotate();
	afx_msg void OnScale();
	afx_msg void OnTranslate();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	virtual BOOL OnInitDialog();
	afx_msg void OnBnClickedTeapot();
	CSliderCtrl m_ASlider;
	CString m_ASliderEcho;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TMODELCONTROL_H__5861448C_B323_4C28_97E5_D7288EEB7955__INCLUDED_)
