#pragma once
#include "afxcmn.h"

#include "./GraphicsAPI/GraphicsAPI.h"

// TrawMeshSurfaceControl dialog

class TmeshSurfaceLibrary;
class TrawMeshSurface;

class TrawMeshSurfaceControl : public CDialog
{
	DECLARE_DYNAMIC(TrawMeshSurfaceControl)

public:
	TrawMeshSurfaceControl(CWnd* pParent = NULL);   // standard constructor
	virtual ~TrawMeshSurfaceControl();

// Dialog Data
	enum { IDD = IDD_RAW_MESH_SURFACE_CONTROL };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()

	TmeshSurfaceLibrary *fL1;	// first drawable
	TmeshSurfaceLibrary *fL2;	// Second drawable

	TrawMeshSurface		*frm1;
	TrawMeshSurface		*frm2;

	D3DXVECTOR3			fP;
	float				fR, fC;

private:
	void 			InitializeSlider(CSliderCtrl&, CString &echo, float min, float max, float init, float);
	void 			UpdateSliderEcho(CString &echo, float value);
	float			GetSliderBarValue(CSliderCtrl&, float);
	void			SetControlVertexPos(float, float, float);

public:

	void			SetMeshLibrary(TmeshSurfaceLibrary *l1, TmeshSurfaceLibrary *l2);
	
	CString m_ColumnEcho;
	CString m_ResolutionEcho;
	CString m_RowEcho;
	CSliderCtrl m_ColumnSlider;
	CSliderCtrl m_RowSlider;
	CSliderCtrl m_ResolutionSlider;
	CString m_MeshXEcho;
	CString m_MeshYEcho;
	CString m_MeshZEcho;
	CSliderCtrl m_MeshXSlider;
	CSliderCtrl m_MeshYSlider;
	CSliderCtrl m_MeshZSlider;
//	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	virtual BOOL OnInitDialog();
	afx_msg void OnNMCustomdrawMeshXSlider(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMCustomdrawMeshYSlider(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMCustomdrawRowSlider(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMCustomdrawColumnSlider(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMCustomdrawMeshZSlider(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMCustomdrawResolutionSlider(NMHDR *pNMHDR, LRESULT *pResult);
};
